/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package API.ServerAdapters;

import com.sun.grizzly.tcp.http11.GrizzlyAdapter;
import com.sun.grizzly.tcp.http11.GrizzlyOutputStream;
import com.sun.grizzly.tcp.http11.GrizzlyRequest;
import com.sun.grizzly.tcp.http11.GrizzlyResponse;
import java.io.File;
import java.io.InputStream;
import utils.OortDebug;
import utils.OortFileUtils;


/**
 *
 * @author richard
 */
public class HTTPServer{
private String LocalPath;
private String AdapterContext;

    public String getAdapterContext() {
    return this.AdapterContext;
    }

    public String getLocalPath() {
        return LocalPath;
    }
    

    public HTTPServer(String LocalPath, String AdapterContext) {
        this.LocalPath = LocalPath;
        this.AdapterContext = AdapterContext;
        OortDebug.out.print("Creating HtmlAdapter for context: "+AdapterContext+" at path: "+LocalPath, this);
        
    }

    public GrizzlyAdapter getAdapter(){
    GrizzlyAdapter ga = new GrizzlyAdapter() {

      @Override
          public void service(GrizzlyRequest req, GrizzlyResponse res) {
          String uri = req.getRequestURI();
          String Resource = LocalPath+uri.substring(uri.lastIndexOf("/")+1);
          OortDebug.out.print("Acessing file: "+Resource+" at context: "+AdapterContext, this);

              File file = new File(Resource);

             if (file.exists()){
                try{
                    String filetype = Resource.toUpperCase().substring(Resource.lastIndexOf(".")+1);
                    OortDebug.out.print(filetype, this);
                    String contentType = "";
                        if (filetype.equals("JPG") || filetype.equals("JPEG")) {
                            contentType = "image/jpeg";
                        } else if (filetype.equals("PNG")) {
                            contentType = "image/png";
                        } else if (filetype.equals("GIF")) {
                            contentType = "image/gif";
                        } else if (filetype.equals("FLV")) {
                            contentType = "application/x-flash-video";
                        } else if (filetype.equals("HTML") || filetype.equals("HTM")) {
                            contentType = "text/html";
                        }
                       
                 OortDebug.out.print(contentType, this);

                       res.setContentType(contentType);
                     //res.setHeader("Content-type", contentType);
                       GrizzlyOutputStream outs = res.getOutputStream();
                       InputStream ins = OortFileUtils.instance.getFileStream(Resource);

                                           // Set variable for looping through bytes.
                         int c;
                         // Loop to read and write bytes.
                         while ((c = ins.read()) != -1)
                            outs.write(c);
                         // Close output and input resources.
                         ins.close();
                         outs.close();


                       res.flushBuffer();
                      
                       
                }catch(Exception e){e.printStackTrace();}
              } else {
                  res.setStatus(404);
                  res.setDetailMessage("Not Found");
              }
               
              
          }
  };

  ga.setHandleStaticResources(true);
  ga.setRootFolder(LocalPath);
  OortDebug.out.print("Gettng HTML adapter: "+AdapterContext+" at path: "+LocalPath, this);
  return ga;

  }

   

    
}
