/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.HashMap;

/**
 *
 * @author richard
 */
public enum OortFileUtils {
instance;
public static final String WORKING_DIRECTORY = System.getProperty("user.dir")+"/";


/**
 * Not implemented at this time
 * @param file
 * @return
 */
public HashMap ParseConfigFile(File file){
    HashMap retMap = new HashMap();
    // open and institue parsing routine //
    return retMap;
}    

 /**
  * Attempts to return the full directory to an Objects file, as its implemented.
  * if it fails to do so will return the CanonicalName
  * @param o
  * @return
  */
 public static String getObjectsDirectory(Object o){
     try{
     return o.getClass().getResource("").getFile();
     
     }catch(Exception e){
     return  o.getClass().getCanonicalName().replace(".", "/");
     }
     
 }
private static void debug(String s){
    System.out.println("(FileUtils): "+s);
}
public static InputStream getFileStream(String FileName){
    InputStream fis = null;
    try{
    File f = new File(FileName);
    fis = new FileInputStream(f);
    }catch(FileNotFoundException fnf){fnf.printStackTrace();}
    catch(IOException ioe){ioe.printStackTrace();}
    return fis;
}
public static OutputStream getOutputStream(String FileName){
    OutputStream os = null;
    try{
    os = new FileOutputStream(new File(FileName));
    }catch(Exception e){e.printStackTrace();}
    return os;
}
 /**
  * This needs to be modernized a bit but you get the idea.. 
  * @param fIn <b> a file that you want read </b>
  * @return the contents of that file as a string.
  */
 public static String getContents(String FileName) {
    //...checks on aFile are elided
    File aFile;
    if(FileName.startsWith("./")){
        FileName = (WORKING_DIRECTORY+"/"+FileName.replace("./",""));
    }
     aFile = new File(FileName);
    debug(FileName);

     String FilePath = "path: ";
    StringBuffer contents = new StringBuffer();
    try {
      //use buffering, reading one line at a time
      //FileReader always assumes default encoding is OK!
      FilePath += aFile.getCanonicalPath();
      BufferedReader input =  new BufferedReader(new FileReader(aFile));
      try {
        String line; //not declared within while loop
        /*
        * readLine is a bit quirky :
        * it returns the content of a line MINUS the newline.
        * it returns null only for the END of the stream.
        * it returns an empty String if two newlines appear in a row.
        */
        while (( line = input.readLine()) != null){
          contents.append(line);
          contents.append(System.getProperty("line.separator"));
         }
      }catch(IOException ioe){ioe.printStackTrace();}

      finally {
        input.close();
      }
      
    }
    catch (IOException ex){
      debug(""+FilePath);
      ex.printStackTrace();
    }

    return ""+contents;
  }

    
}
