/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package API;

/**
 * A data bean that configures and instance of a grizzly web server. Setting Options
 * that are not set in Grizzly by default or are otherwise unintuitive.
 *
 * NOTE: This databean will be passed to the GrizzlyHarness main entry point.
 *
 * @author Richard Corsale
 */
public class HarnessConfig {

    private String RootDirectory;
    private Integer Port;
    private Integer MaxThreads = 80;

    public HarnessConfig(String RootContextDirectory, Integer Port) {
        this.RootDirectory = RootContextDirectory;
        this.Port = Port;
    }

    public Integer getPort() {
        return Port;
    }


    public String getRootDirectory() {
        return RootDirectory;
    }

    public Integer getMaxThreads() {
        return MaxThreads;
    }

    /**
     * Sets the Maximum number of Threads for this server instance.
     * default is 80
     *
     * @param MaxThreads
     */
    public void setMaxThreads(Integer MaxThreads) {
        this.MaxThreads = MaxThreads;
    }





}
